EnableExplicit

IncludeFile "loadscene.pb"
IncludeFile "flame.pb"

Global Player,Speed.f,Rotate.f
Global Loader, Progress, Buffer.s, Width, Height

InitEngine3D():InitKeyboard():InitSprite():InitMouse():InitSound()

UseOGGSoundDecoder()
LoadSound(0,"assets\sounds\World Music - Qi.ogg")
PlaySound(0, #PB_Sound_Loop)

UseJPEGImageDecoder():UseJPEGImageEncoder()
UsePNGImageDecoder():UsePNGImageEncoder()

;Setup window size
ExamineDesktops()
Width = DesktopWidth(0)
Height = DesktopHeight(0)   

OpenWindow(0,0,0, Width, Height, "Happy Birthday PureBasic",#PB_Window_ScreenCentered)
SetWindowColor(0,RGB(105, 105, 105)) 
OpenWindowedScreen(WindowID(0), 0, 0, Width, Height)

Width = ScreenWidth() : Height = ScreenHeight()

Loader = CreateSprite(#PB_Any, Width, Height, #PB_Sprite_AlphaBlending)    

Add3DArchive("assets\skybox\Early_morning.zip", #PB_3DArchive_Zip)

KeyboardMode(#PB_Keyboard_International)

SkyBox("early_morning.jpg")
CreateLight(#PB_Any,RGB(255, 255, 255), -50, 2000, 2000, #PB_Light_Point)
WorldShadows(#PB_Shadow_Additive)

CreateCamera(0, 0, 0, 100, 100)
CameraBackColor(0, RGB(202, 130, 76))

;Player
Player = CreateEntity(-1, MeshID(CreateSphere(-1, 0.9)), #PB_Material_None, 12, 3, 0)
RotateEntity(Player, 0, 90, 0)
HideEntity(Player, #True)

;Load Scene
SceneLoad("demo0.json")

;Show flame particke
FlameShow()

Repeat
  Repeat : Until WindowEvent()=0
  
  Progress = SceneLoadProgress()
  
  If Progress
    SceneLoadProgress()
  Else
    EntityPhysicBody(Player, #PB_Entity_SphereBody)
    If ExamineKeyboard()
      If KeyboardPushed (#PB_Key_Escape)
        Break
      EndIf
      If KeyboardPushed (#PB_Key_Up)
        Speed=- 2
      ElseIf KeyboardPushed(#PB_Key_Down)
        Speed=2
      Else
        Speed = 0.0
      EndIf
      If KeyboardPushed(#PB_Key_Right)
        Rotate=-1.5
      ElseIf KeyboardPushed(#PB_Key_Left)
        Rotate=1.5
      Else
        Rotate=0
      EndIf
      
    EndIf
    RotateEntity(Player,0,rotate,0,#PB_Relative)
    MoveEntity(Player,0,0,speed,#PB_Absolute|#PB_Local)  
  EndIf
  
  CameraFollow(0,EntityID(Player),0,EntityY(Player),1,0.05,1,#True)
  
  RenderWorld(30)
  
  ;Show Loader
  If Progress <> 0 
    StartDrawing(SpriteOutput(Loader))
    DrawingMode(#PB_2DDrawing_AllChannels)
    Box(0, 0, Width, Height, RGBA(0, 0, 0, 200))
    DrawingMode(#PB_2DDrawing_Default)
    RoundBox((Width - 600)/2, (Height-30)/2, 600, 30, 16, 16, RGB(206, 198, 198)) 
    RoundBox((Width - 600)/2, (Height-30)/2, Int(Progress * (600)/100), 30, 16, 16, RGB(128, 128, 128)) 
    DrawingMode(#PB_2DDrawing_Outlined)
    RoundBox((Width - 600)/2, (Height-30)/2, 600, 30, 16, 16, RGB(255, 255, 255)) 
    DrawingMode(#PB_2DDrawing_Transparent)
    Buffer = "Loading progress " + Str(Progress) + " %"
    DrawText((Width - TextWidth(Buffer))/2, 5 + (Height-30)/2, Buffer, RGB(0, 0, 0))
    StopDrawing()
    DisplayTransparentSprite(Loader, 0, 0)
  EndIf
  
  FlipBuffers()
ForEver
; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 12
; FirstLine = 8
; Folding = --
; EnableXP